<?php

require '../../../wp-blog-header.php';
$togglesidebar_manual = get_option('plastic_tunes_togglesidebar_manual');

//Encodes the POST variables
foreach($_POST as $key => $val) {
	${"plastic_tunes_".$key} = Str::gpc2sql($val);
}

//Checks if they passed uid
if ( ! $plastic_tunes_uid ) { 
	update_option('plastic_latest_insert_error', "userID value missing");
	return;
}

//Gets password
$post_password = get_option('plastic_tunes_post_password');
//Checks password, if necessary
if ( $post_password != '' && !check_plastic_tunes_userdata( $plastic_tunes_uid , $plastic_tunes_pw ) ) {
	update_option('plastic_latest_insert_error', "user validation failure");
	return;
}

/*Tells the database whether the player is playing.*/
update_option('plastic_tunes_player_state', $plastic_tunes_state);
/*Checks if player is stopped or paused, in which case end of story */
if ( !$plastic_tunes_state ) {
		update_option('plastic_latest_insert_error', 'player is not playing');		
		return; 
	}
	
/*Checks if artist or title are empty to avoid useless records: 
(for example with network streams that give empty values)

***** IMPORTANT NOTE ******
Note that in this scenario, when player is playing with no new record inserted, 
on the sidebar it will show as if playing the last valid record! It is annoying,
but it is considered better than inserting and showing empty or null values. Also this
pickle happens for when you 'play' after 'pause': in that case you do want
the event to manifest itself as if playing the last valid record.
If you feel that empty records are better than this mishap, comment out the next
elseif statement. If you have in mind a workaround instead, don't esitate
to tell me about it! corpodibacco@gmail.com */
elseif ( !$plastic_tunes_artist || !$plastic_tunes_title ) {
		update_option('plastic_latest_insert_error', 'crucial fields are empty, or no new record inserted');
		return; 
	}
	
/*checks if manual hiding is on, in which case it is the end of the story*/
elseif ($togglesidebar_manual == 'Y') return; 

/*otherwise does the actual insert operations*/
else {
		//sets rating = 0 if not defined
		if ( ! $plastic_tunes_rating ) $plastic_tunes_rating = 'NULL';

		//Checks for post in last X seconds.
		$db_timezone_offset = get_option('plastic_tunes_db_timezone_offset');
		$cur_time = $wpdb->get_row('SELECT UNIX_TIMESTAMP() AS thedate');
		$dbtime_plus_offset = $cur_time->thedate + ( $db_timezone_offset * 60 * 60 );
		$flood_protection_secs = get_option('plastic_tunes_flood_protection_secs');		
		$format_date = get_option('plastic_tunes_format_date');
		$recent_post = $wpdb->get_row('
		SELECT created
		FROM '.$table_prefix.'plastic_tunes
		WHERE user_id = '. $plastic_tunes_uid .'
		AND unix_timestamp(created) > ( unix_timestamp() - '. $flood_protection_secs .' )
		LIMIT 1');		
		if ( $recent_post ) {
		update_option('plastic_latest_insert_error', 'flood Protection');
		return;
		}
		
		//this must be done here for AMIP because other plugins encode differently
		$plastic_tunes_artist = utf8_encode($plastic_tunes_artist);
		$plastic_tunes_album = utf8_encode($plastic_tunes_album);
		$plastic_tunes_title = utf8_encode($plastic_tunes_title);
		$plastic_tunes_genre = utf8_encode($plastic_tunes_genre);		

		//inserts	
		if ( ! is_numeric( $plastic_tunes_rating ) ) $plastic_tunes_rating = 'NULL';
		if ( ! is_numeric( $plastic_tunes_track ) ) $plastic_tunes_track = 'NULL';	
		$wpdb->query("INSERT INTO `". $table_prefix . "plastic_tunes`( `user_id` , `created` , `artist` , `album` , `title` , `rating` , `year` , `track` , `genre` , `duration` ) VALUES ( $plastic_tunes_uid , NOW( ) , '$plastic_tunes_artist', '$plastic_tunes_album', '$plastic_tunes_title', $plastic_tunes_rating ,	'$plastic_tunes_year' , $plastic_tunes_track , '$plastic_tunes_genre', '$plastic_tunes_duration')");
		update_option('plastic_latest_insert_error', "just inserted a new music piece entitled '". $plastic_tunes_title ."'");
	}


//Checks user/pass against db.
function check_plastic_tunes_userdata( $user_id, $pw ) {

	global $wpdb;

	$user_id = (int) $user_id;
	if ( $user_id == 0 ) return false;

	//gets user info
	$user_info = get_userdata( $user_id );
	$min_user_level = get_option('plastic_tunes_min_user_level');

	//Check if user exists
	if ( !$user_info ) return false;
	
	//checks user level
	if ( $user_info->user_level < $min_user_level ) return false;

	$post_password = get_option('plastic_tunes_post_password');

	$db_hash = md5($user_id . $post_password);

	if ( $db_hash == $pw ) return true;
	else return false;

}

/**
Utility class: static methods for cleaning & escaping untrusted (i.e.
user-supplied) strings.

Any string can (usually) be thought of as being in one of these 'modes':

pure = what the user actually typed / what you want to see on the page /
       what is actually stored in the DB
gpc  = incoming GET, POST or COOKIE data
sql  = escaped for passing safely to RDBMS via SQL (also, data from DB
       queries and file reads if you have magic_quotes_runtime on--which
       is rare)
html = safe for html display (htmlentities applied)

Always knowing what mode your string is in--using these methods to
convert between modes--will prevent SQL injection and cross-site scripting.

This class refers to its own namespace (so it can work in PHP 4--there is no
self keyword until PHP 5). Do not change the name of the class w/o changing
all the internal references.

Example usage: a POST value that you want to query with:
$username = Str::gpc2sql($_POST['username']);
*/

//This sets SQL escaping to use slashes; for Sybase(/MSSQL)-style escaping
// ( ' --> '' ), set to true.

define('STR_SYBASE', false);

class Str {
   function gpc2sql($gpc, $maxLength = false)
   {
       return Str::pure2sql(Str::gpc2pure($gpc), $maxLength);
   }
   function gpc2html($gpc, $maxLength = false)
   {
       return Str::pure2html(Str::gpc2pure($gpc), $maxLength);
   }
   function gpc2pure($gpc)
   {
       if (ini_get('magic_quotes_sybase'))
           $pure = str_replace("''", "'", $gpc);
       else $pure = get_magic_quotes_gpc() ? stripslashes($gpc) : $gpc;
       return $pure;
   }
   function html2pure($html)
   {
       return html_entity_decode($html);
   }
   function html2sql($html, $maxLength = false)
   {
       return Str::pure2sql(Str::html2pure($html), $maxLength);
   }
   function pure2html($pure, $maxLength = false)
   {
       return $maxLength ? htmlentities(substr($pure, 0, $maxLength))
                         : htmlentities($pure);
   }
   function pure2sql($pure, $maxLength = false)
   {
       if ($maxLength) $pure = substr($pure, 0, $maxLength);
       return (STR_SYBASE)
               ? str_replace("'", "''", $pure)
               : addslashes($pure);
   }
   function sql2html($sql, $maxLength = false)
   {
       $pure = Str::sql2pure($sql);
       if ($maxLength) $pure = substr($pure, 0, $maxLength);
       return Str::pure2html($pure);
   }
   function sql2pure($sql)
   {
       return (STR_SYBASE)
               ? str_replace("''", "'", $sql)
               : stripslashes($sql);
   }
}
?>